'use strict';

function Cheese() {
}

module.exports = Cheese;

module.exports.ID = 'kr.robomation.physical.cheese';

module.exports.OUTPUT_SA = 0x00d00000;
module.exports.OUTPUT_SB = 0x00d00001;
module.exports.OUTPUT_SC = 0x00d00002;
module.exports.OUTPUT_LA = 0x00d00003;
module.exports.OUTPUT_LB = 0x00d00004;
module.exports.OUTPUT_LC = 0x00d00005;
module.exports.OUTPUT_LX = 0x00d00006;
module.exports.OUTPUT_MAB = 0x00d00007;
module.exports.OUTPUT_MCD = 0x00d00008;
module.exports.BUZZER = 0x00d00009;
module.exports.VELOCITY = 0x00d0000a;
module.exports.STEP = 0x00d0000b;
module.exports.NOTE = 0x00d0000c;
module.exports.SOUND = 0x00d0000d;
module.exports.MODE_SOUND = 0x00d0000e;
module.exports.MODE_SA = 0x00d0000f;
module.exports.MODE_SB = 0x00d00010;
module.exports.MODE_SC = 0x00d00011;
module.exports.MODE_LA = 0x00d00012;
module.exports.MODE_LB = 0x00d00013;
module.exports.MODE_LC = 0x00d00014;
module.exports.MODE_M = 0x00d00015;
module.exports.RED_LED = 0x00d00016;
module.exports.BLUE_LED = 0x00d00017;
module.exports.HAT_OA = 0x00d00018;
module.exports.HAT_OB = 0x00d00019;
module.exports.RESET_ENCODER = 0x00d0001a;
module.exports.WRITE_I2C = 0x00d0001b;
module.exports.WRITE_SERIAL = 0x00d0001c;
module.exports.NEOPIXEL = 0x00d0001d;
module.exports.CONFIG_ADC_SA = 0x00d0001e;
module.exports.CONFIG_ADC_SB = 0x00d0001f;
module.exports.CONFIG_ADC_SC = 0x00d00020;
module.exports.CONFIG_ADC_LA = 0x00d00021;
module.exports.CONFIG_ADC_LB = 0x00d00022;
module.exports.CONFIG_ADC_LC = 0x00d00023;
module.exports.CONFIG_GRAVITY = 0x00d00024;
module.exports.CONFIG_BAND_WIDTH = 0x00d00025;

module.exports.SIGNAL_STRENGTH = 0x00d00030;
module.exports.ACCELERATION = 0x00d00031;
module.exports.TEMPERATURE = 0x00d00032;
module.exports.INPUT_SA = 0x00d00033;
module.exports.INPUT_SB = 0x00d00034;
module.exports.INPUT_SC = 0x00d00035;
module.exports.INPUT_LA = 0x00d00036;
module.exports.INPUT_LB = 0x00d00037;
module.exports.INPUT_LC = 0x00d00038;
module.exports.HAT_IA = 0x00d00039;
module.exports.HAT_IB = 0x00d0003a;
module.exports.FREE_FALL = 0x00d0003b;
module.exports.TAP = 0x00d0003c;
module.exports.READ_I2C = 0x00d0003d;
module.exports.READ_SERIAL = 0x00d0003e;
module.exports.STEP_COUNT = 0x00d0003f;
module.exports.STEP_STATE = 0x00d00040;
module.exports.SOUND_STATE = 0x00d00041;
module.exports.BATTERY_STATE = 0x00d00042;
module.exports.I2C_STATE = 0x00d00043;
module.exports.SERIAL_STATE = 0x00d00044;
module.exports.NEOPIXEL_STATE = 0x00d00045;

module.exports.MODE_SOUND_INTERNAL = 0;
module.exports.MODE_SOUND_SA = 0x40;
module.exports.MODE_SOUND_SB = 0x80;
module.exports.MODE_SOUND_SC = 0xc0;

module.exports.MODE_S_DIGITAL_INPUT = 0;
module.exports.MODE_S_DIGITAL_INPUT_PULL_UP = 1;
module.exports.MODE_S_MAKEY_INPUT = 2;
module.exports.MODE_S_BUTTON_INPUT = 3;
module.exports.MODE_S_ANALOG_INPUT = 4;
module.exports.MODE_S_ANALOG_INPUT_PULL_UP = 5;
module.exports.MODE_S_DIGITAL_OUTPUT = 6;
module.exports.MODE_S_PWM_OUTPUT = 7;
module.exports.MODE_S_SERVO_OUTPUT = 8;

module.exports.MODE_L_DIGITAL_INPUT = 0;
module.exports.MODE_L_DIGITAL_INPUT_PULL_UP = 1;
module.exports.MODE_L_MAKEY_INPUT = 2;
module.exports.MODE_L_BUTTON_INPUT = 3;
module.exports.MODE_L_ANALOG_INPUT = 4;
module.exports.MODE_L_ANALOG_INPUT_PULL_UP = 5;
module.exports.MODE_L_DIGITAL_OUTPUT = 6;
module.exports.MODE_L_PWM_OUTPUT = 7;
module.exports.MODE_L_SERVO_OUTPUT = 8;
module.exports.MODE_L_SERIAL_9600 = 10; // default
module.exports.MODE_L_SERIAL_14400 = 11;
module.exports.MODE_L_SERIAL_19200 = 12;
module.exports.MODE_L_SERIAL_28800 = 13;
module.exports.MODE_L_SERIAL_38400 = 14;
module.exports.MODE_L_SERIAL_57600 = 15;
module.exports.MODE_L_SERIAL_76800 = 16;
module.exports.MODE_L_SERIAL_115200 = 17;
module.exports.MODE_L_ULTRASONIC = 20;
module.exports.MODE_L_ENCODER = 21;
module.exports.MODE_L_DS18B20 = 22;
module.exports.MODE_L_RW1820 = 22;
module.exports.MODE_L_DHT11 = 23;
module.exports.MODE_L_RHT01 = 23;
module.exports.MODE_L_DHT21 = 24;
module.exports.MODE_L_RHT02 = 24;
module.exports.MODE_L_AM2301 = 24;
module.exports.MODE_L_HM2301 = 24;
module.exports.MODE_L_DHT22 = 25;
module.exports.MODE_L_RHT03 = 25;
module.exports.MODE_L_AM2302 = 25;
module.exports.MODE_L_PEAK_DETECTOR = 26;
module.exports.MODE_L_IR_REMOTE_CONTROL = 30;
module.exports.MODE_L_IR_NEC = 31;
module.exports.MODE_L_NEOPIXEL_CLEAR = 40;
module.exports.MODE_L_NEOPIXEL_28_ONOFF = 41;
module.exports.MODE_L_NEOPIXEL_1_GRB = 42;
module.exports.MODE_L_NEOPIXEL_1_GRBW = 43;
module.exports.MODE_L_NEOPIXEL_GRB_PATTERN = 44;
module.exports.MODE_L_NEOPIXEL_GRBW_PATTERN = 45;
module.exports.MODE_L_NEOPIXEL_I2C = 46; // default
module.exports.MODE_L_NEOPIXEL_WRITE = 47;
module.exports.MODE_L_NEOPIXEL_UPDATE = 48;

module.exports.MODE_M_DC = 0x00;
module.exports.MODE_M_SERVO_MONO = 0x10;
module.exports.MODE_M_SERVO_DUAL = 0x20;
module.exports.MODE_M_STEP_OFF = 0x30;
module.exports.MODE_M_STEP_WAVE = 0x31;
module.exports.MODE_M_STEP_FULL = 0x32;
module.exports.MODE_M_STEP_HALF = 0x33;

module.exports.NOTE_OFF = 0;
module.exports.NOTE_A_0 = 1;
module.exports.NOTE_A_SHARP_0 = 2;
module.exports.NOTE_B_FLAT_0 = 2;
module.exports.NOTE_B_0 = 3;
module.exports.NOTE_C_1 = 4;
module.exports.NOTE_C_SHARP_1 = 5;
module.exports.NOTE_D_FLAT_1 = 5;
module.exports.NOTE_D_1 = 6;
module.exports.NOTE_D_SHARP_1 = 7;
module.exports.NOTE_E_FLAT_1 = 7;
module.exports.NOTE_E_1 = 8;
module.exports.NOTE_F_1 = 9;
module.exports.NOTE_F_SHARP_1 = 10;
module.exports.NOTE_G_FLAT_1 = 10;
module.exports.NOTE_G_1 = 11;
module.exports.NOTE_G_SHARP_1 = 12;
module.exports.NOTE_A_FLAT_1 = 12;
module.exports.NOTE_A_1 = 13;
module.exports.NOTE_A_SHARP_1 = 14;
module.exports.NOTE_B_FLAT_1 = 14;
module.exports.NOTE_B_1 = 15;
module.exports.NOTE_C_2 = 16;
module.exports.NOTE_C_SHARP_2 = 17;
module.exports.NOTE_D_FLAT_2 = 17;
module.exports.NOTE_D_2 = 18;
module.exports.NOTE_D_SHARP_2 = 19;
module.exports.NOTE_E_FLAT_2 = 19;
module.exports.NOTE_E_2 = 20;
module.exports.NOTE_F_2 = 21;
module.exports.NOTE_F_SHARP_2 = 22;
module.exports.NOTE_G_FLAT_2 = 22;
module.exports.NOTE_G_2 = 23;
module.exports.NOTE_G_SHARP_2 = 24;
module.exports.NOTE_A_FLAT_2 = 24;
module.exports.NOTE_A_2 = 25;
module.exports.NOTE_A_SHARP_2 = 26;
module.exports.NOTE_B_FLAT_2 = 26;
module.exports.NOTE_B_2 = 27;
module.exports.NOTE_C_3 = 28;
module.exports.NOTE_C_SHARP_3 = 29;
module.exports.NOTE_D_FLAT_3 = 29;
module.exports.NOTE_D_3 = 30;
module.exports.NOTE_D_SHARP_3 = 31;
module.exports.NOTE_E_FLAT_3 = 31;
module.exports.NOTE_E_3 = 32;
module.exports.NOTE_F_3 = 33;
module.exports.NOTE_F_SHARP_3 = 34;
module.exports.NOTE_G_FLAT_3 = 34;
module.exports.NOTE_G_3 = 35;
module.exports.NOTE_G_SHARP_3 = 36;
module.exports.NOTE_A_FLAT_3 = 36;
module.exports.NOTE_A_3 = 37;
module.exports.NOTE_A_SHARP_3 = 38;
module.exports.NOTE_B_FLAT_3 = 38;
module.exports.NOTE_B_3 = 39;
module.exports.NOTE_C_4 = 40;
module.exports.NOTE_C_SHARP_4 = 41;
module.exports.NOTE_D_FLAT_4 = 41;
module.exports.NOTE_D_4 = 42;
module.exports.NOTE_D_SHARP_4 = 43;
module.exports.NOTE_E_FLAT_4 = 43;
module.exports.NOTE_E_4 = 44;
module.exports.NOTE_F_4 = 45;
module.exports.NOTE_F_SHARP_4 = 46;
module.exports.NOTE_G_FLAT_4 = 46;
module.exports.NOTE_G_4 = 47;
module.exports.NOTE_G_SHARP_4 = 48;
module.exports.NOTE_A_FLAT_4 = 48;
module.exports.NOTE_A_4 = 49;
module.exports.NOTE_A_SHARP_4 = 50;
module.exports.NOTE_B_FLAT_4 = 50;
module.exports.NOTE_B_4 = 51;
module.exports.NOTE_C_5 = 52;
module.exports.NOTE_C_SHARP_5 = 53;
module.exports.NOTE_D_FLAT_5 = 53;
module.exports.NOTE_D_5 = 54;
module.exports.NOTE_D_SHARP_5 = 55;
module.exports.NOTE_E_FLAT_5 = 55;
module.exports.NOTE_E_5 = 56;
module.exports.NOTE_F_5 = 57;
module.exports.NOTE_F_SHARP_5 = 58;
module.exports.NOTE_G_FLAT_5 = 58;
module.exports.NOTE_G_5 = 59;
module.exports.NOTE_G_SHARP_5 = 60;
module.exports.NOTE_A_FLAT_5 = 60;
module.exports.NOTE_A_5 = 61;
module.exports.NOTE_A_SHARP_5 = 62;
module.exports.NOTE_B_FLAT_5 = 62;
module.exports.NOTE_B_5 = 63;
module.exports.NOTE_C_6 = 64;
module.exports.NOTE_C_SHARP_6 = 65;
module.exports.NOTE_D_FLAT_6 = 65;
module.exports.NOTE_D_6 = 66;
module.exports.NOTE_D_SHARP_6 = 67;
module.exports.NOTE_E_FLAT_6 = 67;
module.exports.NOTE_E_6 = 68;
module.exports.NOTE_F_6 = 69;
module.exports.NOTE_F_SHARP_6 = 70;
module.exports.NOTE_G_FLAT_6 = 70;
module.exports.NOTE_G_6 = 71;
module.exports.NOTE_G_SHARP_6 = 72;
module.exports.NOTE_A_FLAT_6 = 72;
module.exports.NOTE_A_6 = 73;
module.exports.NOTE_A_SHARP_6 = 74;
module.exports.NOTE_B_FLAT_6 = 74;
module.exports.NOTE_B_6 = 75;
module.exports.NOTE_C_7 = 76;
module.exports.NOTE_C_SHARP_7 = 77;
module.exports.NOTE_D_FLAT_7 = 77;
module.exports.NOTE_D_7 = 78;
module.exports.NOTE_D_SHARP_7 = 79;
module.exports.NOTE_E_FLAT_7 = 79;
module.exports.NOTE_E_7 = 80;
module.exports.NOTE_F_7 = 81;
module.exports.NOTE_F_SHARP_7 = 82;
module.exports.NOTE_G_FLAT_7 = 82;
module.exports.NOTE_G_7 = 83;
module.exports.NOTE_G_SHARP_7 = 84;
module.exports.NOTE_A_FLAT_7 = 84;
module.exports.NOTE_A_7 = 85;
module.exports.NOTE_A_SHARP_7 = 86;
module.exports.NOTE_B_FLAT_7 = 86;
module.exports.NOTE_B_7 = 87;
module.exports.NOTE_C_8 = 88;

module.exports.SOUND_OFF = 0;
module.exports.SOUND_BEEP = 1;
module.exports.SOUND_RANDOM_BEEP = 2;
module.exports.SOUND_NOISE = 10;
module.exports.SOUND_SIREN = 3;
module.exports.SOUND_ENGINE = 4;
module.exports.SOUND_CHOP = 11;
module.exports.SOUND_ROBOT = 5;
module.exports.SOUND_DIBIDIBIDIP = 8;
module.exports.SOUND_GOOD_JOB = 9;
module.exports.SOUND_HAPPY = 12;
module.exports.SOUND_ANGRY = 13;
module.exports.SOUND_SAD = 14;
module.exports.SOUND_SLEEP = 15;
module.exports.SOUND_MARCH = 6;
module.exports.SOUND_BIRTHDAY = 7;

module.exports.BATTERY_NORMAL = 2;
module.exports.BATTERY_LOW = 1;
module.exports.BATTERY_EMPTY = 0;