'use strict';

function Hamster() {
}

module.exports = Hamster;

module.exports.ID = 'kr.robomation.physical.hamster';

module.exports.LEFT_WHEEL = 0x00400000;
module.exports.RIGHT_WHEEL = 0x00400001;
module.exports.BUZZER = 0x00400002;
module.exports.OUTPUT_A = 0x00400003;
module.exports.OUTPUT_B = 0x00400004;
module.exports.TOPOLOGY = 0x00400005;
module.exports.LEFT_LED = 0x00400006;
module.exports.RIGHT_LED = 0x00400007;
module.exports.NOTE = 0x00400008;
module.exports.LINE_TRACER_MODE = 0x00400009;
module.exports.LINE_TRACER_SPEED = 0x0040000a;
module.exports.IO_MODE_A = 0x0040000b;
module.exports.IO_MODE_B = 0x0040000c;
module.exports.CONFIG_PROXIMITY = 0x0040000d;
module.exports.CONFIG_GRAVITY = 0x0040000e;
module.exports.CONFIG_BAND_WIDTH = 0x0040000f;

module.exports.SIGNAL_STRENGTH = 0x00400010;
module.exports.LEFT_PROXIMITY = 0x00400011;
module.exports.RIGHT_PROXIMITY = 0x00400012;
module.exports.LEFT_FLOOR = 0x00400013;
module.exports.RIGHT_FLOOR = 0x00400014;
module.exports.ACCELERATION = 0x00400015;
module.exports.LIGHT = 0x00400016;
module.exports.TEMPERATURE = 0x00400017;
module.exports.INPUT_A = 0x00400018;
module.exports.INPUT_B = 0x00400019;
module.exports.LINE_TRACER_STATE = 0x0040001a;
module.exports.TILT = 0x0040001b;
module.exports.BATTERY_STATE = 0x0040001c;

module.exports.TOPOLOGY_NONE = 0;
module.exports.TOPOLOGY_DAISY_CHAIN = 1;
module.exports.TOPOLOGY_STAR = 2;
module.exports.TOPOLOGY_EXTENDED_STAR = 3;

module.exports.LED_OFF = 0;
module.exports.LED_BLUE = 1;
module.exports.LED_GREEN = 2;
module.exports.LED_CYAN = 3;
module.exports.LED_RED = 4;
module.exports.LED_MAGENTA = 5;
module.exports.LED_YELLOW = 6;
module.exports.LED_WHITE = 7;

module.exports.LINE_TRACER_MODE_OFF = 0;
module.exports.LINE_TRACER_MODE_BLACK_LEFT_SENSOR = 1;
module.exports.LINE_TRACER_MODE_BLACK_RIGHT_SENSOR = 2;
module.exports.LINE_TRACER_MODE_BLACK_BOTH_SENSORS = 3;
module.exports.LINE_TRACER_MODE_BLACK_TURN_LEFT = 4;
module.exports.LINE_TRACER_MODE_BLACK_TURN_RIGHT = 5;
module.exports.LINE_TRACER_MODE_BLACK_MOVE_FORWARD = 6;
module.exports.LINE_TRACER_MODE_BLACK_UTURN = 7;
module.exports.LINE_TRACER_MODE_WHITE_LEFT_SENSOR = 8;
module.exports.LINE_TRACER_MODE_WHITE_RIGHT_SENSOR = 9;
module.exports.LINE_TRACER_MODE_WHITE_BOTH_SENSORS = 10;
module.exports.LINE_TRACER_MODE_WHITE_TURN_LEFT = 11;
module.exports.LINE_TRACER_MODE_WHITE_TURN_RIGHT = 12;
module.exports.LINE_TRACER_MODE_WHITE_MOVE_FORWARD = 13;
module.exports.LINE_TRACER_MODE_WHITE_UTURN = 14;

module.exports.IO_MODE_ANALOG_INPUT = 0;
module.exports.IO_MODE_DIGITAL_INPUT = 1;
module.exports.IO_MODE_SERVO_OUTPUT = 8;
module.exports.IO_MODE_PWM_OUTPUT = 9;
module.exports.IO_MODE_DIGITAL_OUTPUT = 10;

module.exports.NOTE_OFF = 0;
module.exports.NOTE_A_0 = 1;
module.exports.NOTE_A_SHARP_0 = 2;
module.exports.NOTE_B_FLAT_0 = 2;
module.exports.NOTE_B_0 = 3;
module.exports.NOTE_C_1 = 4;
module.exports.NOTE_C_SHARP_1 = 5;
module.exports.NOTE_D_FLAT_1 = 5;
module.exports.NOTE_D_1 = 6;
module.exports.NOTE_D_SHARP_1 = 7;
module.exports.NOTE_E_FLAT_1 = 7;
module.exports.NOTE_E_1 = 8;
module.exports.NOTE_F_1 = 9;
module.exports.NOTE_F_SHARP_1 = 10;
module.exports.NOTE_G_FLAT_1 = 10;
module.exports.NOTE_G_1 = 11;
module.exports.NOTE_G_SHARP_1 = 12;
module.exports.NOTE_A_FLAT_1 = 12;
module.exports.NOTE_A_1 = 13;
module.exports.NOTE_A_SHARP_1 = 14;
module.exports.NOTE_B_FLAT_1 = 14;
module.exports.NOTE_B_1 = 15;
module.exports.NOTE_C_2 = 16;
module.exports.NOTE_C_SHARP_2 = 17;
module.exports.NOTE_D_FLAT_2 = 17;
module.exports.NOTE_D_2 = 18;
module.exports.NOTE_D_SHARP_2 = 19;
module.exports.NOTE_E_FLAT_2 = 19;
module.exports.NOTE_E_2 = 20;
module.exports.NOTE_F_2 = 21;
module.exports.NOTE_F_SHARP_2 = 22;
module.exports.NOTE_G_FLAT_2 = 22;
module.exports.NOTE_G_2 = 23;
module.exports.NOTE_G_SHARP_2 = 24;
module.exports.NOTE_A_FLAT_2 = 24;
module.exports.NOTE_A_2 = 25;
module.exports.NOTE_A_SHARP_2 = 26;
module.exports.NOTE_B_FLAT_2 = 26;
module.exports.NOTE_B_2 = 27;
module.exports.NOTE_C_3 = 28;
module.exports.NOTE_C_SHARP_3 = 29;
module.exports.NOTE_D_FLAT_3 = 29;
module.exports.NOTE_D_3 = 30;
module.exports.NOTE_D_SHARP_3 = 31;
module.exports.NOTE_E_FLAT_3 = 31;
module.exports.NOTE_E_3 = 32;
module.exports.NOTE_F_3 = 33;
module.exports.NOTE_F_SHARP_3 = 34;
module.exports.NOTE_G_FLAT_3 = 34;
module.exports.NOTE_G_3 = 35;
module.exports.NOTE_G_SHARP_3 = 36;
module.exports.NOTE_A_FLAT_3 = 36;
module.exports.NOTE_A_3 = 37;
module.exports.NOTE_A_SHARP_3 = 38;
module.exports.NOTE_B_FLAT_3 = 38;
module.exports.NOTE_B_3 = 39;
module.exports.NOTE_C_4 = 40;
module.exports.NOTE_C_SHARP_4 = 41;
module.exports.NOTE_D_FLAT_4 = 41;
module.exports.NOTE_D_4 = 42;
module.exports.NOTE_D_SHARP_4 = 43;
module.exports.NOTE_E_FLAT_4 = 43;
module.exports.NOTE_E_4 = 44;
module.exports.NOTE_F_4 = 45;
module.exports.NOTE_F_SHARP_4 = 46;
module.exports.NOTE_G_FLAT_4 = 46;
module.exports.NOTE_G_4 = 47;
module.exports.NOTE_G_SHARP_4 = 48;
module.exports.NOTE_A_FLAT_4 = 48;
module.exports.NOTE_A_4 = 49;
module.exports.NOTE_A_SHARP_4 = 50;
module.exports.NOTE_B_FLAT_4 = 50;
module.exports.NOTE_B_4 = 51;
module.exports.NOTE_C_5 = 52;
module.exports.NOTE_C_SHARP_5 = 53;
module.exports.NOTE_D_FLAT_5 = 53;
module.exports.NOTE_D_5 = 54;
module.exports.NOTE_D_SHARP_5 = 55;
module.exports.NOTE_E_FLAT_5 = 55;
module.exports.NOTE_E_5 = 56;
module.exports.NOTE_F_5 = 57;
module.exports.NOTE_F_SHARP_5 = 58;
module.exports.NOTE_G_FLAT_5 = 58;
module.exports.NOTE_G_5 = 59;
module.exports.NOTE_G_SHARP_5 = 60;
module.exports.NOTE_A_FLAT_5 = 60;
module.exports.NOTE_A_5 = 61;
module.exports.NOTE_A_SHARP_5 = 62;
module.exports.NOTE_B_FLAT_5 = 62;
module.exports.NOTE_B_5 = 63;
module.exports.NOTE_C_6 = 64;
module.exports.NOTE_C_SHARP_6 = 65;
module.exports.NOTE_D_FLAT_6 = 65;
module.exports.NOTE_D_6 = 66;
module.exports.NOTE_D_SHARP_6 = 67;
module.exports.NOTE_E_FLAT_6 = 67;
module.exports.NOTE_E_6 = 68;
module.exports.NOTE_F_6 = 69;
module.exports.NOTE_F_SHARP_6 = 70;
module.exports.NOTE_G_FLAT_6 = 70;
module.exports.NOTE_G_6 = 71;
module.exports.NOTE_G_SHARP_6 = 72;
module.exports.NOTE_A_FLAT_6 = 72;
module.exports.NOTE_A_6 = 73;
module.exports.NOTE_A_SHARP_6 = 74;
module.exports.NOTE_B_FLAT_6 = 74;
module.exports.NOTE_B_6 = 75;
module.exports.NOTE_C_7 = 76;
module.exports.NOTE_C_SHARP_7 = 77;
module.exports.NOTE_D_FLAT_7 = 77;
module.exports.NOTE_D_7 = 78;
module.exports.NOTE_D_SHARP_7 = 79;
module.exports.NOTE_E_FLAT_7 = 79;
module.exports.NOTE_E_7 = 80;
module.exports.NOTE_F_7 = 81;
module.exports.NOTE_F_SHARP_7 = 82;
module.exports.NOTE_G_FLAT_7 = 82;
module.exports.NOTE_G_7 = 83;
module.exports.NOTE_G_SHARP_7 = 84;
module.exports.NOTE_A_FLAT_7 = 84;
module.exports.NOTE_A_7 = 85;
module.exports.NOTE_A_SHARP_7 = 86;
module.exports.NOTE_B_FLAT_7 = 86;
module.exports.NOTE_B_7 = 87;
module.exports.NOTE_C_8 = 88;

module.exports.WHEEL_CENTER_DISTANCE = 1.675;
module.exports.PEN_CENTER_DISTANCE = 2.475;

module.exports.BATTERY_NORMAL = 2;
module.exports.BATTERY_LOW = 1;
module.exports.BATTERY_EMPTY = 0;