'use strict';

function Turtle() {
}

module.exports = Turtle;

module.exports.ID = 'kr.robomation.physical.turtle';

module.exports.LEFT_WHEEL = 0x00900000;
module.exports.RIGHT_WHEEL = 0x00900001;
module.exports.LED = 0x00900002;
module.exports.BUZZER = 0x00900003;
module.exports.PULSE = 0x00900004;
module.exports.NOTE = 0x00900005;
module.exports.SOUND = 0x00900006;
module.exports.LINE_TRACER_MODE = 0x00900007;
module.exports.LINE_TRACER_GAIN = 0x00900008;
module.exports.LINE_TRACER_SPEED = 0x00900009;
module.exports.LAMP = 0x0090000a;
module.exports.LOCK = 0x0090000b;
module.exports.MOTION = 0x0090000c;

module.exports.SIGNAL_STRENGTH = 0x0090000d;
module.exports.COLOR = 0x0090000e;
module.exports.FLOOR = 0x0090000f;
module.exports.ACCELERATION = 0x00900010;
module.exports.TEMPERATURE = 0x00900011;
module.exports.BUTTON = 0x00900012;
module.exports.CLICKED = 0x00900013;
module.exports.DOUBLE_CLICKED = 0x00900014;
module.exports.LONG_PRESSED = 0x00900015;
module.exports.COLOR_NUMBER = 0x00900016;
module.exports.COLOR_PATTERN = 0x00900017;
module.exports.PULSE_COUNT = 0x00900018;
module.exports.WHEEL_STATE = 0x00900019;
module.exports.SOUND_STATE = 0x0090001a;
module.exports.LINE_TRACER_STATE = 0x0090001b;
module.exports.TILT = 0x0090001c;
module.exports.BATTERY_STATE = 0x0090001d;

module.exports.COLOR_NONE = -1;
module.exports.COLOR_BLACK = 0;
module.exports.COLOR_RED = 1;
module.exports.COLOR_ORANGE = 2;
module.exports.COLOR_YELLOW = 3;
module.exports.COLOR_GREEN = 4;
module.exports.COLOR_CYAN = 5;
module.exports.COLOR_BLUE = 6;
module.exports.COLOR_MAGENTA = 7;
module.exports.COLOR_WHITE = 8;

module.exports.LINE_TRACER_MODE_OFF = 0;
module.exports.LINE_TRACER_MODE_BLACK = 10;
module.exports.LINE_TRACER_MODE_RED = 11;
module.exports.LINE_TRACER_MODE_GREEN = 13;
module.exports.LINE_TRACER_MODE_BLUE = 15;
module.exports.LINE_TRACER_MODE_ANY = 17;
module.exports.LINE_TRACER_MODE_TURN_LEFT = 20;
module.exports.LINE_TRACER_MODE_TURN_RIGHT = 30;
module.exports.LINE_TRACER_MODE_CROSS = 40;
module.exports.LINE_TRACER_MODE_UTURN = 50;
module.exports.LINE_TRACER_MODE_BLACK_UNTIL_RED = 61;
module.exports.LINE_TRACER_MODE_BLACK_UNTIL_YELLOW = 62;
module.exports.LINE_TRACER_MODE_BLACK_UNTIL_GREEN = 63;
module.exports.LINE_TRACER_MODE_BLACK_UNTIL_CYAN = 64;
module.exports.LINE_TRACER_MODE_BLACK_UNTIL_BLUE = 65;
module.exports.LINE_TRACER_MODE_BLACK_UNTIL_MAGENTA = 66;
module.exports.LINE_TRACER_MODE_BLACK_UNTIL_ANY = 67;
module.exports.LINE_TRACER_MODE_RED_UNTIL_BLACK = 71;
module.exports.LINE_TRACER_MODE_GREEN_UNTIL_BLACK = 73;
module.exports.LINE_TRACER_MODE_BLUE_UNTIL_BLACK = 75;
module.exports.LINE_TRACER_MODE_ANY_UNTIL_BLACK = 77;

module.exports.NOTE_OFF = 0;
module.exports.NOTE_A_0 = 1;
module.exports.NOTE_A_SHARP_0 = 2;
module.exports.NOTE_B_FLAT_0 = 2;
module.exports.NOTE_B_0 = 3;
module.exports.NOTE_C_1 = 4;
module.exports.NOTE_C_SHARP_1 = 5;
module.exports.NOTE_D_FLAT_1 = 5;
module.exports.NOTE_D_1 = 6;
module.exports.NOTE_D_SHARP_1 = 7;
module.exports.NOTE_E_FLAT_1 = 7;
module.exports.NOTE_E_1 = 8;
module.exports.NOTE_F_1 = 9;
module.exports.NOTE_F_SHARP_1 = 10;
module.exports.NOTE_G_FLAT_1 = 10;
module.exports.NOTE_G_1 = 11;
module.exports.NOTE_G_SHARP_1 = 12;
module.exports.NOTE_A_FLAT_1 = 12;
module.exports.NOTE_A_1 = 13;
module.exports.NOTE_A_SHARP_1 = 14;
module.exports.NOTE_B_FLAT_1 = 14;
module.exports.NOTE_B_1 = 15;
module.exports.NOTE_C_2 = 16;
module.exports.NOTE_C_SHARP_2 = 17;
module.exports.NOTE_D_FLAT_2 = 17;
module.exports.NOTE_D_2 = 18;
module.exports.NOTE_D_SHARP_2 = 19;
module.exports.NOTE_E_FLAT_2 = 19;
module.exports.NOTE_E_2 = 20;
module.exports.NOTE_F_2 = 21;
module.exports.NOTE_F_SHARP_2 = 22;
module.exports.NOTE_G_FLAT_2 = 22;
module.exports.NOTE_G_2 = 23;
module.exports.NOTE_G_SHARP_2 = 24;
module.exports.NOTE_A_FLAT_2 = 24;
module.exports.NOTE_A_2 = 25;
module.exports.NOTE_A_SHARP_2 = 26;
module.exports.NOTE_B_FLAT_2 = 26;
module.exports.NOTE_B_2 = 27;
module.exports.NOTE_C_3 = 28;
module.exports.NOTE_C_SHARP_3 = 29;
module.exports.NOTE_D_FLAT_3 = 29;
module.exports.NOTE_D_3 = 30;
module.exports.NOTE_D_SHARP_3 = 31;
module.exports.NOTE_E_FLAT_3 = 31;
module.exports.NOTE_E_3 = 32;
module.exports.NOTE_F_3 = 33;
module.exports.NOTE_F_SHARP_3 = 34;
module.exports.NOTE_G_FLAT_3 = 34;
module.exports.NOTE_G_3 = 35;
module.exports.NOTE_G_SHARP_3 = 36;
module.exports.NOTE_A_FLAT_3 = 36;
module.exports.NOTE_A_3 = 37;
module.exports.NOTE_A_SHARP_3 = 38;
module.exports.NOTE_B_FLAT_3 = 38;
module.exports.NOTE_B_3 = 39;
module.exports.NOTE_C_4 = 40;
module.exports.NOTE_C_SHARP_4 = 41;
module.exports.NOTE_D_FLAT_4 = 41;
module.exports.NOTE_D_4 = 42;
module.exports.NOTE_D_SHARP_4 = 43;
module.exports.NOTE_E_FLAT_4 = 43;
module.exports.NOTE_E_4 = 44;
module.exports.NOTE_F_4 = 45;
module.exports.NOTE_F_SHARP_4 = 46;
module.exports.NOTE_G_FLAT_4 = 46;
module.exports.NOTE_G_4 = 47;
module.exports.NOTE_G_SHARP_4 = 48;
module.exports.NOTE_A_FLAT_4 = 48;
module.exports.NOTE_A_4 = 49;
module.exports.NOTE_A_SHARP_4 = 50;
module.exports.NOTE_B_FLAT_4 = 50;
module.exports.NOTE_B_4 = 51;
module.exports.NOTE_C_5 = 52;
module.exports.NOTE_C_SHARP_5 = 53;
module.exports.NOTE_D_FLAT_5 = 53;
module.exports.NOTE_D_5 = 54;
module.exports.NOTE_D_SHARP_5 = 55;
module.exports.NOTE_E_FLAT_5 = 55;
module.exports.NOTE_E_5 = 56;
module.exports.NOTE_F_5 = 57;
module.exports.NOTE_F_SHARP_5 = 58;
module.exports.NOTE_G_FLAT_5 = 58;
module.exports.NOTE_G_5 = 59;
module.exports.NOTE_G_SHARP_5 = 60;
module.exports.NOTE_A_FLAT_5 = 60;
module.exports.NOTE_A_5 = 61;
module.exports.NOTE_A_SHARP_5 = 62;
module.exports.NOTE_B_FLAT_5 = 62;
module.exports.NOTE_B_5 = 63;
module.exports.NOTE_C_6 = 64;
module.exports.NOTE_C_SHARP_6 = 65;
module.exports.NOTE_D_FLAT_6 = 65;
module.exports.NOTE_D_6 = 66;
module.exports.NOTE_D_SHARP_6 = 67;
module.exports.NOTE_E_FLAT_6 = 67;
module.exports.NOTE_E_6 = 68;
module.exports.NOTE_F_6 = 69;
module.exports.NOTE_F_SHARP_6 = 70;
module.exports.NOTE_G_FLAT_6 = 70;
module.exports.NOTE_G_6 = 71;
module.exports.NOTE_G_SHARP_6 = 72;
module.exports.NOTE_A_FLAT_6 = 72;
module.exports.NOTE_A_6 = 73;
module.exports.NOTE_A_SHARP_6 = 74;
module.exports.NOTE_B_FLAT_6 = 74;
module.exports.NOTE_B_6 = 75;
module.exports.NOTE_C_7 = 76;
module.exports.NOTE_C_SHARP_7 = 77;
module.exports.NOTE_D_FLAT_7 = 77;
module.exports.NOTE_D_7 = 78;
module.exports.NOTE_D_SHARP_7 = 79;
module.exports.NOTE_E_FLAT_7 = 79;
module.exports.NOTE_E_7 = 80;
module.exports.NOTE_F_7 = 81;
module.exports.NOTE_F_SHARP_7 = 82;
module.exports.NOTE_G_FLAT_7 = 82;
module.exports.NOTE_G_7 = 83;
module.exports.NOTE_G_SHARP_7 = 84;
module.exports.NOTE_A_FLAT_7 = 84;
module.exports.NOTE_A_7 = 85;
module.exports.NOTE_A_SHARP_7 = 86;
module.exports.NOTE_B_FLAT_7 = 86;
module.exports.NOTE_B_7 = 87;
module.exports.NOTE_C_8 = 88;

module.exports.SOUND_OFF = 0;
module.exports.SOUND_BEEP = 1;
module.exports.SOUND_RANDOM_BEEP = 2;
module.exports.SOUND_SIREN = 3;
module.exports.SOUND_ENGINE = 4;
module.exports.SOUND_ROBOT = 5;
module.exports.SOUND_MARCH = 6;
module.exports.SOUND_BIRTHDAY = 7;
module.exports.SOUND_DIBIDIBIDIP = 8;
module.exports.SOUND_GOOD_JOB = 9;

module.exports.MOTION_NONE = 0;
module.exports.MOTION_MOVE_FORWARD = 1;
module.exports.MOTION_MOVE_BACKWARD = 2;
module.exports.MOTION_TURN_LEFT = 3;
module.exports.MOTION_TURN_RIGHT = 4;
module.exports.MOTION_PIVOT_LEFT_HEAD = 5;
module.exports.MOTION_PIVOT_LEFT_TAIL = 6;
module.exports.MOTION_PIVOT_RIGHT_HEAD = 7;
module.exports.MOTION_PIVOT_RIGHT_TAIL = 8;
module.exports.MOTION_SWING_LEFT_HEAD = 9;
module.exports.MOTION_SWING_LEFT_TAIL = 10;
module.exports.MOTION_SWING_RIGHT_HEAD = 11;
module.exports.MOTION_SWING_RIGHT_TAIL = 12;

module.exports.UNIT_NONE = 0;
module.exports.UNIT_CM_DEG = 1;
module.exports.UNIT_SEC = 2;
module.exports.UNIT_PULSE = 3;

module.exports.CM_TO_PULSE = 106.8;
module.exports.DEG_TO_PULSE = 1570;
module.exports.WHEEL_DISTANCE = 2.3125; // wheel-center distance
module.exports.WHEEL_DISTANCE_10000 = 23125;