'use strict';
function Server() {
}

Server.prototype.__start = function(handler) {
	var restart = handler.needsRestart();
	var serverName = handler.getServerName();
	var module = handler.getModule();
	var extension = handler.getExtension();
	var port = handler.getPort();
	
	if(!module || !extension) return;
	
	if(this.server && (restart || this.serverName != serverName || this.module != module || this.extension != extension || this.port != port)) {
		this.server.stop();
		this.server = undefined;
	}
	this.serverName = serverName;
	this.module = module;
	this.extension = extension;
	this.port = port;
	if(this.server == undefined) {
		var path = '../../modules/' + module + extension;
		this.server = require('./' + serverName);
		this.server.start(path, port, this.option, handler.getCallback());
	}
};

Server.prototype.start = function(handler, option) {
	this.option = option;
	if(handler) {
		this.handler = handler;
		this.__start(handler);
	}
};

Server.prototype.stop = function() {
	if(this.server) {
		this.server.stop();
		this.server = undefined;
	}
	this.option = undefined;
	this.handler = undefined;
	this.serverName = undefined;
	this.module = undefined;
	this.extension = undefined;
	this.port = undefined;
};

Server.prototype.restartForSingleRobot = function(route) {
	var handler = this.handler;
	if(handler) {
		var module = this.module;
		if(module && module != 'all' && module != route.module) {
			this.__start(handler);
		}
	}
};

Server.prototype.restartForMultiRobots = function() {
	var handler = this.handler;
	if(handler) {
		this.__start(handler);
	}
};

Server.prototype.getModule = function() {
	return this.module;
};

Server.prototype.setState = function(route) {
	if(this.server) {
		this.server.setState(route);
	}
};

Server.prototype.setOption = function(option) {
	if(this.server) {
		this.server.setOption(option);
	}
};

module.exports = new Server();